## ros-humble-pal-statistics 2.1.5

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5.0)
project(pal_statistics)

find_package(ament_cmake_auto REQUIRED)
ament_auto_find_build_dependencies()

ament_auto_add_library(${PROJECT_NAME} SHARED
        src/pal_statistics_utils.cpp src/pal_statistics.cpp
        src/pal_statistics_macros.cpp src/registration_list.cpp)

# ##############################################################################
# Testing ##
# ##############################################################################

if(BUILD_TESTING)
  ament_auto_find_test_dependencies()
  ament_lint_auto_find_test_dependencies()

  ament_auto_add_gtest(buffer-test test/gtest_buffer.cpp)

  ament_add_gmock(pal_statistics-test test/gtest_pal_statistics.cpp
    TIMEOUT 180)
  target_include_directories(
    pal_statistics-test PRIVATE src) # dirty hack for a forward declaration
  target_link_libraries(pal_statistics-test ${PROJECT_NAME})

  # TODO python migration add_rostest(test/pal_statistics_py.test)
endif()

ament_auto_package()

=== debian/changelog ===
ros-humble-pal-statistics (2.1.5-1jammy) jammy; urgency=high

  * miscellaneous enhancements
  * refactor gtest_pal_statistics to test also lifecycle nodes
  * add support for lifecycle nodes
  * add namespace for StaticCircularBuffer
  * Contributors: Noel Jimenez

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Fri, 14 Apr 2023 00:00:00 -0000

ros-humble-pal-statistics (2.1.4-1jammy) jammy; urgency=high

  * Merge branch 'fix_warns' into 'humble-devel'
    Fix warns
    See merge request qa/pal_statistics!28
  * change types for comparisons
  * reorder variable initialization
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Thu, 02 Mar 2023 00:00:00 -0000

ros-humble-pal-statistics (2.1.3-1jammy) jammy; urgency=high

  * Merge branch 'fix_linter' into 'humble-devel'
    fix linter
    See merge request qa/pal_statistics!27
  * fix linter
  * Contributors: Jordan Palacios, Noel Jimenez

 -- victor <victor.lopez@pal-robotics.com>  Wed, 07 Sep 2022 00:00:00 -0000

ros-humble-pal-statistics (2.1.2-1jammy) jammy; urgency=high



 -- victor <victor.lopez@pal-robotics.com>  Mon, 05 Sep 2022 00:00:00 -0000

ros-humble-pal-statistics (2.1.1-1jammy) jammy; urgency=high



 -- victor <victor.lopez@pal-robotics.com>  Tue, 09 Nov 2021 00:00:00 -0000

ros-humble-pal-statistics (2.1.0-1jammy) jammy; urgency=high

  * Revert "Comment out tests that require galactic rclpcpp API"
    This reverts commit 6642f6a743e5d5be210f7e59191153746b296866.
  * Fix cmake lint
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Fri, 15 Oct 2021 00:00:00 -0000

ros-humble-pal-statistics (2.0.0-1jammy) jammy; urgency=high

  * Comment out tests that require galactic rclpcpp API
  * Use ament_cmake_auto
  * Update package.xml
  * Add comment about ament_cmake_pal
  * Change license to BSD-3 Clause
  * Flake8 and pep257 compliance
  * Add ament dependencies
  * More formatting and header ordering
  * Apply ament_link_cmake
  * Cpplint compliance
  * Rename headers to .h and uncrustify them
  * Fix double comparisons in test
  * Reorganize code to remove boost from include files
  * Tests passing in ROS2
  * Update license on headers
    refs #5 <https://github.com/pal-robotics/pal_statistics/issues/5>
  * Change License to MIT
    fixes #5 <https://github.com/pal-robotics/pal_statistics/issues/5>
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Fri, 15 Oct 2021 00:00:00 -0000

ros-humble-pal-statistics (1.4.0-1jammy) jammy; urgency=high

  * Merge branch 'use-atomic-bool' into 'erbium-devel'
    Use atomic bool, because we need atomic operation
    See merge request qa/pal_statistics!18
  * Use atomic bool, because we need atomic operation
  * Contributors: Victor Lopez, victor

 -- victor <victor.lopez@pal-robotics.com>  Fri, 13 Mar 2020 00:00:00 -0000

ros-humble-pal-statistics (1.3.1-1jammy) jammy; urgency=high

  * Fix shadow variable warning
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Wed, 28 Aug 2019 00:00:00 -0000

ros-humble-pal-statistics (1.3.0-1jammy) jammy; urgency=high

  * Merge branch 'async-optimizations' into 'erbium-devel'
    Optimize async update when everything is enabled
    See merge request qa/pal_statistics!17
  * Smarter clear and resize of vectors when all enabled
  * Optimize async update when everything is enabled
  * Add LGPL3 version text
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Mon, 12 Aug 2019 00:00:00 -0000

ros-humble-pal-statistics (1.2.1-1jammy) jammy; urgency=high

  * Fix stamp of full messages
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Thu, 18 Apr 2019 00:00:00 -0000

ros-humble-pal-statistics (1.2.0-1jammy) jammy; urgency=high

  * Merge branch 'optimized-msg' into 'erbium-devel'
    Optimized msg
    See merge request qa/pal_statistics!15
  * Update python api to new msgs
  * Rename full statistics topic
  * Add new messages
  * Change internal structure from vector of pairs to pair of vectors
  * Add missing add_dependencies
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Tue, 16 Apr 2019 00:00:00 -0000

ros-humble-pal-statistics (1.1.1-1jammy) jammy; urgency=high

  * Merge branch 'correct-stamp' into 'erbium-devel'
    Correct stamp
    See merge request qa/pal_statistics!14
  * Add macros with variable argument count
  * Set time stamp from main thread
  * Fix maintainer
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Wed, 19 Dec 2018 00:00:00 -0000

ros-humble-pal-statistics (1.1.0-1jammy) jammy; urgency=high

  * Merge branch 'fix-test' into 'erbium-devel'
    Fix spurious test failure when buffer was filled
    See merge request qa/pal_statistics!12
  * Fix spurious test failure when buffer was filled
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Mon, 29 Oct 2018 00:00:00 -0000

ros-humble-pal-statistics (1.0.8-1jammy) jammy; urgency=high

  * Fix some issues with copyable object that shouldn't be
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Thu, 25 Oct 2018 00:00:00 -0000

ros-humble-pal-statistics (1.0.7-1jammy) jammy; urgency=high

  * Change Sleep to WallSleep
    When sim time stops being published. The thread can get stuck and never
    end.
  * Fix unitialized variable
  * Contributors: Victor Lopez

 -- victor <victor.lopez@pal-robotics.com>  Thu, 25 Oct 2018 00:00:00 -0000

ros-humble-pal-statistics (1.0.6-1jammy) jammy; urgency=high

  * Merge branch 'improve-constness' into 'erbium-devel'
    Change namespace to pal_statistics and and const to double *
    Closes #5
    See merge request qa/pal_statistics!11
  * Add tests for registration modification between pubAsync and publishing
  * Change namespace to pal_statistics and and const to double *
    Fixes https://gitlab/qa/pal_statistics/issues/5
  * Contributors: Victor Lopez



=== debian/control ===
Source: ros-humble-pal-statistics
Section: misc
Priority: optional
Maintainer: Jordan Palacios <jordan.palacios@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-humble-ament-cmake-auto, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-pal-statistics-msgs, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-rclpy, ros-humble-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-humble-pal-statistics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-humble-pal-statistics-msgs, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-rclpy, ros-humble-ros-workspace
Description: The pal_statistics package

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-pal-statistics//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install

## ros-humble-pal-statistics 2.3.1

=== debian/changelog ===
ros-humble-pal-statistics (2.3.1-1bookworm) bookworm; urgency=high

  * Ensure the value is converted to float before creating the msg
  * Contributors: David ter Kuile

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Wed, 28 Aug 2024 16:00:00 -0000

ros-humble-pal-statistics (2.3.0-1bookworm) bookworm; urgency=high

  * Remove unused files
  * update qos for ros2
  * Port test
  * Port statistics_registry.py
  * Contributors: David ter Kuile

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Wed, 28 Aug 2024 16:00:00 -0000

ros-humble-pal-statistics (2.2.4-1bookworm) bookworm; urgency=high

  * Use enabled_.swap instead of std::swap.
    This allows this package to compile on modern g++,
    on Ubuntu 24.04.
  * Contributors: Chris Lalancette

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Wed, 15 May 2024 16:00:00 -0000

ros-humble-pal-statistics (2.2.3-1bookworm) bookworm; urgency=high

  * Merge branch 'fix/flaky_macro_asyncPublisher' into 'humble-devel'
    Fix/flaky macro async publisher
    See merge request qa/pal_statistics!36
  * Improve test failure messages
  * Make gtest failure messages more informative in aync tests
    For instance from:
    /home/user/exchange/roses/alum/pal_statistics_ws/src/pal_statistics/pal_statistics/test/gtest_pal_statistics.cpp:580: Failure
    Value of: waitFor( std::bind( stats_published_for, "macro_var1", "clp-failure", "macro_var1_bk", "macro_var2", "&var2_"))
    Actual: false
    Expected: true
    to:
    /home/user/exchange/roses/alum/pal_statistics_ws/src/pal_statistics/pal_statistics/test/gtest_pal_statistics.cpp:673: Failure
    After 300 msValue of: get_variables
    Expected: has 9 elements and there exists some permutation of elements such that:
    - element #0 is equal to "macro_var1", and
    - element #1 is equal to "clp-failure", and
    - element #2 is equal to "macro_var1_bk", and
    - element #3 is equal to "macro_var2", and
    - element #4 is equal to "&var2_", and
    - element #5 is equal to "topic_stats.pal_statistics_node_test/pal_statistics.publish_async_attempts", and
    - element #6 is equal to "topic_stats.pal_statistics_node_test/pal_statistics.publish_async_failures", and
    - element #7 is equal to "topic_stats.pal_statistics_node_test/pal_statistics.publish_buffer_full_errors", and
    - element #8 is equal to "topic_stats.pal_statistics_node_test/pal_statistics.last_async_pub_duration"
    Actual: { "topic_stats.pal_statistics_node_test/pal_statistics.publish_async_attempts", "topic_stats.pal_statistics_node_test/pal_statistics.publish_async_failures", "topic_stats.pal_statistics_node_test/al_statistics.publish_buffer_full_errors", "topic_stats.pal_statistics_node_test/pal_statistics.last_async_pub_duration", "macro_var1", "macro_var1_bk", "macro_var2", "&var2_" }, which has 8 elements
  * Create helpers for better failure messages in async tests
  * Fix time units in messages
  * Fix c++17 already enforced
  * Make tests exit when requested
  * Clean up unused functions
  * macroTest: prevent some flakiness
  * asyncPublisherTest: prevent some flakiness
  * Contributors: Carles Lopez Parera, Jordan Palacios

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Sun, 17 Dec 2023 16:00:00 -0000

ros-humble-pal-statistics (2.2.2-1bookworm) bookworm; urgency=high

  * Add website tag
  * Contributors: Noel Jimenez

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Mon, 13 Nov 2023 16:00:00 -0000

ros-humble-pal-statistics (2.2.1-1bookworm) bookworm; urgency=high

  * Merge branch 'fix/flaky_chaos_test' into 'humble-devel'
    Fix flakiness in chaos tests
    See merge request qa/pal_statistics!34
  * Fix flakiness in chaos tests
  * Contributors: Carles Lopez Parera, Jordan Palacios

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Mon, 13 Nov 2023 16:00:00 -0000

ros-humble-pal-statistics (2.2.0-1bookworm) bookworm; urgency=high

  * Merge branch 'fix/crash_when_start_publish_called_twice_for_same_topic' into 'humble-devel'
    Fix: prevent crash when publisher thread is recreated
    See merge request qa/pal_statistics!33
  * Use make_shared as per CR
  * Test statistics publish thread can be called multiple times
  * Fix: interrupt_thread flag could stay true forever
    This hinders the execution of the publisher thread, making
    it exit prematurely.
    For instance, in case joinPublisherThread() is called when no
    publisher_thread_ is still ready:
    1. startPublishThread()
    1.1. joinPublisherThread()
    1.1.1. interrupt_thread_ set to true
    1.1.2. publisher_thread_ is null, no further actions
    1.2. new thread created for publisherThreadCycle()
    2. In publisherThreadCycle, interrupt_thread_ is true
    2.1. thread finishes
  * Fix use proper event to interrupt the publisher thread
  * Fix: prevent crash when publisher thread is recreated
    publisher thread was destroyed before being joined causing
    the termination of the process
    See: https://en.cppreference.com/w/cpp/thread/thread/%7Ethread
  * Contributors: Carles Lopez Parera, Jordan Palacios

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Wed, 18 Oct 2023 16:00:00 -0000

ros-humble-pal-statistics (2.1.5-1bookworm) bookworm; urgency=high

  * miscellaneous enhancements
  * refactor gtest_pal_statistics to test also lifecycle nodes
  * add support for lifecycle nodes
  * add namespace for StaticCircularBuffer
  * Contributors: Noel Jimenez

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Thu, 13 Apr 2023 16:00:00 -0000

ros-humble-pal-statistics (2.1.4-1bookworm) bookworm; urgency=high

  * Merge branch 'fix_warns' into 'humble-devel'
    Fix warns
    See merge request qa/pal_statistics!28
  * change types for comparisons
  * reorder variable initialization
  * Contributors: Jordan Palacios, Noel Jimenez

 -- Jordan Palacios <jordan.palacios@pal-robotics.com>  Wed, 01 Mar 2023 16:00:00 -0000

ros-humble-pal-statistics (2.1.3-1bookworm) bookworm; urgency=high



=== debian/control ===
Source: ros-humble-pal-statistics
Section: misc
Priority: optional
Maintainer: Jordan Palacios <jordan.palacios@pal-robotics.com>
Build-Depends: debhelper (>= 9.0.0), libboost-all-dev, ros-humble-ament-cmake-auto, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-pytest <!nocheck>, ros-humble-ament-cmake-python, ros-humble-ament-lint-auto <!nocheck>, ros-humble-ament-lint-common <!nocheck>, ros-humble-pal-statistics-msgs, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-rclpy, ros-humble-ros-workspace
Homepage: https://github.com/pal-robotics/pal_statistics
Standards-Version: 3.9.2

Package: ros-humble-pal-statistics
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libboost-all-dev, ros-humble-pal-statistics-msgs, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-rclpy, ros-humble-ros-workspace
Description: The pal_statistics package

=== debian/rules ===
--- 
+++ 
@@ -57,7 +57,7 @@
 	# in the install tree and source it.  It will set things like
 	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
 	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
-	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-pal-statistics//opt/ros/humble/lib/
+	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-pal-statistics//opt/ros/humble/lib/:$(CURDIR)/debian/ros-humble-pal-statistics//opt/ros/humble/opt/pal_statistics/lib/
 
 override_dh_auto_install:
 	# In case we're installing to a non-standard location, look for a setup.sh
